package sim.app.ubik.states.talkingAgentsSpectatorStates;

import sim.app.ubik.behaviors.*;
import sim.app.ubik.building.rooms.Room;
import sim.app.ubik.people.Person;

public class AutomatonTalkingAgentsSpectator extends FSM {

	public AutomatonTalkingAgentsSpectator(Person p) {
		super(p);

		Room salaPrimera = PositionTools.getRoom(p, "salaPrimera");
		Room salaSegunda = PositionTools.getRoom(p, "salaSegunda");
		Room salaTercera = PositionTools.getRoom(p, "salaTercera");

		Automaton startState = new DoNothing(p, 0, 15, "starting");

		Automaton movingToFirstRoom = new Move(p, 0, -1, "movingToFirstRoom", salaPrimera.getCenter().x, salaPrimera.
				getCenter().y);
		Automaton stayingInFirstRoom = new DoNothing(p, 0, 15, "stayingInFirstRoom");

		Automaton movingToSecondRoom = new Move(p, 0, -1, "movingToSecondRoom", salaSegunda.getCenter().x, salaSegunda.
				getCenter().y);
		Automaton stayingInSecondRoom = new DoNothing(p, 0, 15, "stayingInSecondRoom");

		Automaton movingToThirdRoom = new Move(p, 0, -1, "movingToThirdRoom", salaTercera.getCenter().x, salaTercera.
				getCenter().y);
		Automaton stayingInThirdRoom = new DoNothing(p, 0, 15, "stayingInThirdRoom");

		Automaton movingToExit = new Move(p, 0, -1, "movingToExit", "salida");

		this.registerStartState(startState);
		this.registerTransition(startState, movingToFirstRoom);
		this.registerTransition(movingToFirstRoom, stayingInFirstRoom);
		this.registerTransition(stayingInFirstRoom, movingToSecondRoom);
		this.registerTransition(movingToSecondRoom, stayingInSecondRoom);
		this.registerTransition(stayingInSecondRoom, movingToThirdRoom);
		this.registerTransition(movingToThirdRoom, stayingInThirdRoom);
		this.registerTransition(stayingInThirdRoom, movingToExit);
		this.registerFinalState(movingToExit);
	}
}
